############################################################################
Summary: Opens an SSH tunnel to the CS50 Appliance.
Name: tunnel50
Version: 1.0
Release: 1
License: CC BY-NC-SA 3.0
Group: Applications/Productivity
Source: %{name}-%{version}-%{release}
Vendor: CS50
URL: https://manual.cs50.net/tunnel50
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: cs50-appliance
Requires: initscripts
Requires: logmein-hamachi
Requires(post): logmein-hamachi
Requires: openssh-clients
Requires: php-cli
Requires: php-process
Requires: redhat-lsb
Requires: screen
Requires(post): screen
Requires(pre): shadow-utils
Requires: sudo
BuildArch: i386


############################################################################
%define _optdir /opt


############################################################################
# ensure RPM is portable by avoiding rpmlib(FileDigests)
# http://lists.rpm.org/pipermail/rpm-list/2009-October/000401.html
%global _binary_filedigest_algorithm 1
%global _source_filedigest_algorithm 1


############################################################################
# ensure RPM is portable by avoiding rpmlib(PayloadIsXz)
# http://www.cmake.org/pipermail/cmake/2010-March/035580.html
%global _binary_payload w9.gzdio


############################################################################
%description
tunnel50 is a command-line tool that students use in CS50
to allow staff to connect to their CS50 Appliance.


############################################################################
%pre

# /etc/passwd
/usr/sbin/adduser --home /opt/tunnel50 --shell /bin/bash --system tunnel50 > /dev/null 2>&1

# return 0
/bin/true


############################################################################
%install
/bin/rm -rf %{buildroot}
/bin/mkdir -p %{buildroot}
/bin/cp -a %{_sourcedir}/%{name}-%{version}-%{release}/* %{buildroot}/
/bin/mkdir -p %{buildroot}%{_bindir}
/bin/ln -s %{_optdir}/%{name}/bin/%{name} %{buildroot}%{_bindir}/%{name}


############################################################################
%post

# conserve resources
/sbin/service logmein-hamachi stop 2>&1 > /dev/null
/sbin/chkconfig logmein-hamachi off 2>&1 > /dev/null

# http://magazine.redhat.com/2007/09/27/a-guide-to-gnu-screen/
/bin/chmod u+s /usr/bin/screen 2>&1 > /dev/null
/bin/chmod 755 /var/run/screen 2>&1 > /dev/null


############################################################################
%clean
/bin/rm -rf %{buildroot}


############################################################################
%files

%defattr(-,root,root,-)
%{_bindir}/%{name}

%defattr(-,tunnel50,tunnel50,-)
%{_optdir}/%{name}/

%defattr(0600,tunnel50,tunnel50,0700)
%{_optdir}/%{name}/.ssh

%defattr(0440,root,root,-)
/etc/sudoers.d/tunnel50


############################################################################
%changelog
* Tue Sep 20 2011 David J. Malan <malan@harvard.edu> - 1.0-1
- Initial build
